@rem Copyright (c) 2011 Valve Corporation 
@rem 
@rem Permission is hereby granted, free of charge, to any person obtaining a copy of
@rem this software and associated documentation files (the "Software"), to deal in
@rem the Software without restriction, including without limitation the rights to use,
@rem copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the
@rem Software, and to permit persons to whom the Software is furnished to do so,
@rem subject to the following conditions:
@rem 
@rem The above copyright notice and this permission notice shall be included in all
@rem copies or substantial portions of the Software.
@rem 
@rem THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
@rem IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
@rem FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
@rem COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
@rem IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
@rem WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

@setlocal

@rem Customize to specify the location of your provider DLL or EXE

@set DLLFileMain=Debug\MultiProvider.exe
@set DLLFileAlternate=Release\MultiProvider.exe
@set ManifestFileMain=etwprovider.man
@set ManifestFileAlternate=etwprovider.man





@echo This will register the custom ETW providers.

@set DLLFile=%DLLFileMain%
@if exist %DLLFile% goto tier0OK
@set DLLFile=%DLLFileAlternate%
@if not exist %DLLFile% goto NoTier0
@:tier0OK

@set ManifestFile=%ManifestFileMain%
@if exist %ManifestFile% goto manifestOK
@set ManifestFile=%ManifestFileAlternate%
@if not exist %ManifestFile% goto NoManifest
@:manifestOK

xcopy /y %DLLFile% %temp%
wevtutil um %ManifestFile%
@if %errorlevel% == 5 goto NotElevated
wevtutil im %ManifestFile%
@exit /b

@:NotElevated
@echo ETW providers must be registered from an elevated (administrator) command
@echo prompt. Try again from an elevated prompt.
@exit /b

@:NoTier0
@echo Can't find %DLLFileMain% or %DLLFileAlternate%
@exit /b

@:NoManifest
@echo Can't find %ManifestFileMain% or %ManifestFileAlternate%
@exit /b
